//On a Mac, uncomment these and comment out PC includes below
//#include "SWindows.h"
//#include "Graphics.h"
//#include "Delay.h"
//#include "Mouse.h"

//On a PC, uncomment these and comment out the includes above 
#include "ct_windows.h"
#include "ct_graphics.h"
#include "ct_mouse.h"
#include "ct_delay.h"

#include <stdlib.h>

#include "IOTools.h"
#include "MathUtil.h"
#include "Random.h"    // for RandomLong(..) 

// Borders are global constants
const int  TOP_BORDER    = 50;
const int  BOTTOM_BORDER = 350;
const int  LEFT_BORDER   = 20;
const int  RIGHT_BORDER  = 380;

int main(){

    BigSquarePair();
    SetRandomSeed();   // set current time as the random seed

    // set and draw the border walls
    SetForeColor( 255, 0, 0 );
    FrameRect( LEFT_BORDER, TOP_BORDER, RIGHT_BORDER, BOTTOM_BORDER );

    // variables describing the ball:
    
    int x = 200;   // x-coordinate
    int y = 200;   // y-coordinate
    int vx = 5;  // velocity along the x-axis 
    int vy = -5;  // velocity along the y-axis 
    int rad = 20;  // radius of the ball  

    for(int t=0; t<1000; t++){  // time
        // comupute the new position
        int new_x = x + vx;
        int new_y = y + vy;

        // Check if the ball is at the boundary and reflect it if so.
        //
        // The ball is contained in the rectangle with the corners
        // (x-rad, y-rad), (x+rad, y+rad), (x-rad, y+rad), (x+rad, y-rad) .  
        // 
        // If either of these four points lies on the border or beyond, 
        // the ball will collide with the border on the next move

        if( new_x - rad <= LEFT_BORDER  ||  new_x + rad >= RIGHT_BORDER ) 
              vx = -vx;  // change the direction along the x-axis

        if( new_y - rad <= TOP_BORDER   ||  new_y + rad >= BOTTOM_BORDER ) 
              vy = -vy;  // change the direction along the y-axis

        SetForeColor( 255, 255, 255 );  // white
        PaintCircle( x, y, rad );       // erase the ball
        
        x += vx;      // update the coords of the ball
        y += vy; 

        SetForeColor( 0, 0, 255 );      // blue
        PaintCircle( x, y, rad );    

        Delay(20);        // delay so that the animation is not too fast 
    }

    PressReturn();

    return 0;
}
